//BOCrossbow.cs

//audio
datablock AudioProfile(BOCrossbowfireSound)
{
   filename    = "./BOCrossbowfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BOCrossbowExplosionSound)
{
   filename    = "./BOExplosion1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BOCrossbowClipinSound)
{
   filename    = "./BOCrossbowclipin.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BOCrossbowTactSound)
{
   filename    = "./BOHIT.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BOCrossbowClipoutSound)
{
   filename    = "./BOCrossbowclipout.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BOCrossbowdeploySound)
{
   filename    = "./BOCrossbowdeploy.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BOCrossbowhitSound)
{
   filename    = "./BOCrossbowBHit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock DecalData(BOCrossbowDecal)
{
 textureName = "./CI_BOCrossbow";
};

datablock PlayerData(BOCrossbowArmor : PlayerStandardArmor)
{
	firstPersonOnly=1;

   runForce = 10 * 180;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 2.7;
   maxBackwardSpeed = 2.7;
   maxSideSpeed = 2.7;

   maxForwardCrouchSpeed = 1.8;
   maxBackwardCrouchSpeed = 1.6;
   maxSideCrouchSpeed = 1.6;

   jumpForce = 8 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;


	uiName = "";
	showEnergyBar = false;

   runSurfaceAngle  = 45;
   jumpSurfaceAngle = 45;
};

datablock ParticleData(BOCrossbowflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./bullethole.png";
	spinSpeed		= 0.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0.0 0.0 0.0 0.0";
	colors[1]     = "0.0 0.0 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 0.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BOCrossbowflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BOCrossbowflashParticle";

};

//Bullet Explosion
datablock ExplosionData(BOCrossbowexplosion)
{
   explosionShape = "add-ons/Weapon_Rocket Launcher/explosionSphere1.dts";
   soundProfile = BOCrossbowExplosionSound;

   lifeTimeMS = 150;

   particleEmitter = rocketExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "0.5 0.5 0.5";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "0.9 0.9 0";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 1;
   impulseForce = 500;

   //radius damage
   damageRadius = 10;
   radiusDamage = 150;

};

datablock ParticleData(BOCrossbowExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/Star1";
	spinSpeed		   = 10.0;
	spinRandomMin	   = -50.0;
	spinRandomMax	   = 50.0;
	colors[0]     = "0.9 0.9 0.6 0.9";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 1.0;

	useInvAlpha = true;
};

datablock ExplosionData(BOCrossbowMW2weaponRecoilExplosion)
{
  lifeTimeMS = 10;
  explosionScale = "0 1 0";
  shakeCamera = true;
  camShakeFreq = "0 1 0";
  camShakeAmp = "0 1 0";
  camShakeDuration = 0.5;
  camShakeRadius = 0.5;
};

datablock ProjectileData(BOCrossbowMW2weaponRecoil)
{
  uiName = "";
  explosion = BOCrossbowMW2weaponRecoilExplosion;
  muzzleVelocity = 0;
  velInheritFactor = 1;
  lifetime = 1;
  fadeDelay = 1;
  explodeOnDeath = true;
};

AddDamageType("BOCrossbow",   '<bitmap:add-ons/Weapon_BO_Crossbow/CI_BOCrossbow> %1',    '%2 <bitmap:add-ons/Weapon_BO_Crossbow/CI_BOCrossbow> %1',0.2,1);
datablock ProjectileData(BOCrossbowprojectile)
{
   projectileShapeName = "./Arrow.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::BOCrossbow;
   radiusDamageType    = $DamageType::BOCrossbow;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 2;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 3;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 200;
   verticalImpulse   = 600;
   explosion	     = BOCrossbowExplosion;
   particleEmitter     = rocketTrailEmitter;
   explodeOnDeath	     = true;

   muzzleVelocity      = 100;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 30000;
   fadeDelay           = 25000;
   bounceAngle         = 170; //stick almost all the time
   minStickVelocity    = 10;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;   
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = true;
   lightRadius = 1;
   lightColor  = "0.9 0.9 0";
};


AddDamageType("BOCrossbows",   '<bitmap:add-ons/Weapon_BO_Crossbow/CI_BOCrossbow> %1',    '%2 <bitmap:add-ons/Weapon_BO_Crossbow/CI_BOCrossbow> %1',0.2,1);
datablock ProjectileData(BOCrossbowsprojectile)
{
   projectileShapeName = "./Arrow.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::BOCrossbows;
   radiusDamageType    = $DamageType::BOCrossbows;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 2;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 3;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 200;
   verticalImpulse   = 600;
   explosion	     = BOCrossbowExplosion;
   particleEmitter     = rocketTrailEmitter;
   explodeOnDeath	     = true;

   muzzleVelocity      = 100;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 30000;
   fadeDelay           = 25000;
   bounceAngle         = 170; //stick almost all the time
   minStickVelocity    = 10;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;   
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = true;
   lightRadius = 1;
   lightColor  = "0.9 0.9 0";

   uiName = "ExplBolt";
};

//////////
// item //
//////////
datablock ItemData(BOCrossbowItem)
{
	category = "Weapon";
	className = "Weapon"; 

	 // Basic Item Properties
	shapeFile = "./BrBOCrossbow.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "BO Crossbow_Explosive";
	iconName = "./Icon_BOCrossbow";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = BOCrossbowImage;
	canDrop = true;
	
	//Ammo Guns Parameters
	maxAmmo = 1;
	canReload = 1;
};

datablock ShapeBaseImageData(BOCrossbowImage)
{
   // Basic Item properties
   shapeFile = "./BOCrossbow.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = BOCrossbowItem;
   ammo = " ";
   projectile = BOCrossbowprojectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = BOCrossbowItem.colorShiftColor;
   // Initial start up state - Ammo mod by Space Guy, base states taken from L4Pistol by Bushido!
   raycastExplosionPlayerSound = BOCrossbowTactSound;
   raycastExplosionBrickSound = BOCrossbowhitSound;

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.3;
	stateTransitionOnTimeout[0]     = "LoadCheckA";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "ClipOut";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 0.3;
	stateTransitionOnTimeout[2]     = "Smoke";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= BOCrossbowflashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= BOCrossbowfireSound;
	stateEjectShell[2]              = true;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateTimeoutValue[3]	= 0.03;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTimeout[3]	= "FireLoadCheckA";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.03;
	stateScript[4]                  = "";
	stateTransitionOnTriggerUp[4] = "Delay";
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "ReadyWeap";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.5;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "Clipout";

	stateName[8]				= "ClipOut";
	stateTimeoutValue[8]			= 1.0;
	stateScript[8]				= "onReloadStart";
	stateSequence[8]		= "Clipout";
	stateAllowImageChange[8]        = true;
	stateTransitionOnTimeout[8]		= "Clipin";
	stateSound[8]				= BOCrossbowclipoutSound;
	
	stateName[9]				= "Clipin";
	stateTimeoutValue[9]			= 2.8;
	stateScript[9]				= "";
	stateSequence[9]		= "Clipin";
	stateAllowImageChange[9]        = true;
	stateTransitionOnTimeout[9]		= "reloadFinish";
	stateSound[9]				= BOCrossbowclipinSound;
	
	stateName[10]				= "reloadFinish";
	stateTimeoutValue[10]			= 0.2;
	stateScript[10]				= "onReloaded";
	stateAllowImageChange[10]        = true;
	stateTransitionOnTimeout[10]		= "Ready";
	
	stateName[11]				= "FireLoadCheckA";
	stateScript[11]				= "onLoadCheck";
	stateTimeoutValue[11]			= 0.01;
	stateTransitionOnTimeout[11]		= "FireLoadCheckB";
	
	stateName[12]				= "FireLoadCheckB";
	stateTransitionOnAmmo[12]		= "Wait";
	stateTransitionOnNoAmmo[12]		= "ReloadWait";
	
	stateName[13]				= "Delay";
	stateTransitionOnTimeout[13]		= "Ready";
	stateTimeoutValue[13] 			= 0.00001;
	
	stateName[14]				= "ReadyWeap";
	stateSequence[14]			= "Use";
	stateTimeoutValue[14] 			= 0.8;
	stateSound[14]			= BOCrossbowdeploySound;
	stateTransitionOnTimeout[14]		= "Ready";
};
datablock ShapeBaseImageData(BOCrossbowSightsImage)
{
   shapeFile = "./BOCrossbow.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "-0.6083 -0.45 -2.07";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = BOCrossbowItem;
   ammo = " ";
   projectile = BOCrossbowsprojectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;
   canDrop = true;

   doColorShift = true;
   colorShiftColor = BOCrossbowItem.colorShiftColor;
   raycastExplosionPlayerSound = BOCrossbowTactSound;
   raycastExplosionBrickSound = BOCrossbowhitSound;   

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.01;
	stateTransitionOnTimeout[0]     = "LoadCheckA";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "reloadSequence";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 0.3;
	stateTransitionOnTimeout[2]     = "Smoke";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= BOCrossbowflashEmitter;
	stateEmitterTime[2]		= 0.03;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= BOCrossbowfireSound;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateTimeoutValue[3]		= 0.04;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTimeout[3] = "FireLoadCheckA";

	stateName[4]			= "Wait";
	stateEjectShell[2]              = true;
	stateTimeoutValue[4]		= 0.05;
	stateScript[4]                  = "";
	stateTransitionOnTriggerUp[4] = "Delay";
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "Ready";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "reloadSequence";
	
	stateName[8]				= "reloadSequence";
	stateScript[8]				= "setBOCrossbowZorro";
	
	stateName[9]				= "FireLoadCheckA";
	stateScript[9]				= "onLoadCheck";
	stateTimeoutValue[9]			= 0.01;
	stateTransitionOnTimeout[9]		= "FireLoadCheckB";
	
	stateName[10]				= "FireLoadCheckB";
	stateTransitionOnAmmo[10]		= "Wait";
	stateTransitionOnNoAmmo[10]		= "ReloadWait";
	
	stateName[11]				= "Delay";
	stateTransitionOnTimeout[11]		= "Ready";
	stateTimeoutValue[11]			= 0.106;
};


datablock ShapeBaseImageData(BOCrossbowBackImage)
{
  shapeFile = "./BrBOCrossbow.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "0.2 -0.7 -0.1";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("0 25 0");
  armReady = false;
  doColorShift = false;
};

function BOCrossbow2SpawnProj(%this,%obj,%slot)
{
	if(vectorLen(%obj.getVelocity()) < 0.5 && (getSimTime() - %obj.lastShotTime) > 500)
		%spread = 0.000;
	else
		%spread = 0.000;
	if(vectorLen(%obj.getVelocity()) < 1 && (getSimTime() - %obj.lastShotTime) > 600 && %obj.getMountedImage(0) == nameToID(BOCrossbowSightsImage))
		%spread = 0.000;
	else if(vectorLen(%obj.getVelocity()) < 1 && (getSimTime() - %obj.lastShotTime) > 1150 && %obj.getMountedImage(0) == nameToID(BOCrossbowSightsImage))
		%spread = 0.000;

	%p = new (%this.projectileType)()
	{
    	  dataBlock = BOCrossbowMW2weaponRecoil;
    	  initialVelocity = VectorAdd(%vector1,%vector2);
    	  initialPosition = %obj.getEyePoint();
    	  sourceObject = %obj;
    	  sourceSlot = %slot;
    	  client = %obj.client;
  	};
	%projectile = BOCrossbowsprojectile;
	%shellcount = 1;
        	%obj.toolAmmo[%obj.currTool]--;
	%obj.lastShotTime = getSimTime();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function BOCrossbowSightsImage::onFire(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool]--;
      	%obj.client.quantity["BOCrossbowReloadCount"] += 1; 
      	commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["BOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4);
            	if(%obj.toolAmmo[%obj.currTool] >= 2)
            	{
            	%obj.toolAmmo[%obj.currTool] = 1;
            	}	

	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		BOCrossbow2SpawnProj(%this,%obj,%slot);
	}
	else if(%this.item.maxAmmo == 0)
	{
		BOCrossbow2SpawnProj(%this,%obj,%slot);
	}
		Parent::onFire(%this,%obj,%slot);
}


function BOCrossbowImage::onFire(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool]--;
      	%obj.client.quantity["BOCrossbowReloadCount"] += 1; 
      	commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["BOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4);
            	if(%obj.toolAmmo[%obj.currTool] >= 2)
            	{
            	%obj.toolAmmo[%obj.currTool] = 1;
            	}	

	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		BOCrossbowSpawnProj(%this,%obj,%slot);
	}
	else if(%this.item.maxAmmo == 0)
	{
		BOCrossbowSpawnProj(%this,%obj,%slot);
	}
		Parent::onFire(%this,%obj,%slot);
}	

function BOCrossbowImage::onReloadStart(%this,%obj,%slot)
{
    if(%obj.client.quantity["BOCrossbowReloadAmmo"] == 0)
    {
    commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["BOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4);
    return;
    }
//	%obj.toolAmmo[%obj.currTool] = 0;
}


function BOCrossbowImage::onReloaded(%this,%obj,%slot)
{

	if(%obj.client.quantity["BOCrossbowReloadAmmo"] >= 1)
        {
        if(%obj.client.quantity["BOCrossbowReloadAmmo"] >= 1)
            {
            %obj.client.quantity["BOCrossbowReloadAmmo"] -= %obj.client.quantity["BOCrossbowReloadCount"];
	        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	        %obj.setImageAmmo(%slot,1);
            if(%obj.client.quantity["BOCrossbowReloadAmmo"] < 1)
            {
            %obj.client.quantity["BOCrossbowReloadAmmo"] = 0;
            }
            if(%obj.toolAmmo[%obj.currTool] >= 2)
            {
            %obj.toolAmmo[%obj.currTool] = 1;
            }
            commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: 1 | " @ %obj.client.quantity["BOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4); 
            %obj.client.quantity["BOCrossbowReloadCount"] = 0;
            }
        else
            {
	        %obj.toolAmmo[%obj.currTool] += %obj.client.quantity["BOCrossbowReloadAmmo"];  
	        %obj.setImageAmmo(%slot,1);
            %obj.client.quantity["BOCrossbowReloadAmmo"] = 0;
            if(%obj.client.quantity["BOCrossbowReloadAmmo"] < 1)
            {
            %obj.client.quantity["BOCrossbowReloadAmmo"] = 0;
            }
            if(%obj.toolAmmo[%obj.currTool] >= 2)
            {
            %obj.toolAmmo[%obj.currTool] = 1;
            }
            commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["BOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4); 
            %obj.client.quantity["BOCrossbowReloadCount"] = 0;
            }
        }
    else
        {
        messageClient(%client,'','\c3Man, You ain\'t got the weapon for this');
        }
	%obj.mountImage(BOCrossbowImage, 0, 0, 0);
}

function BOCrossbowmage::onReloadWait(%this,%obj,%slot)
{
    if(%obj.client.quantity["BOCrossbowReloadAmmo"] == 0)
    {
    commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["BOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4);
    return;
    }
}

function BOCrossbowSpawnProj(%this,%obj,%slot)
{
	if(vectorLen(%obj.getVelocity()) < 0.5 && (getSimTime() - %obj.lastShotTime) > 500)
		%spread = 0.002;
	else
		%spread = 0.008;
	if(vectorLen(%obj.getVelocity()) < 1 && (getSimTime() - %obj.lastShotTime) > 600 && %obj.getMountedImage(0) == nameToID(BOCrossbowSightsImage))
		%spread = 0.005;
	else if(vectorLen(%obj.getVelocity()) < 1 && (getSimTime() - %obj.lastShotTime) > 1150 && %obj.getMountedImage(0) == nameToID(BOCrossbowSightsImage))
		%spread = 0.002;


	%projectile = BOCrossbowprojectile;
	%shellcount = 1;
        	%obj.toolAmmo[%obj.currTool]--;
	%obj.lastShotTime = getSimTime();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function BOCrossbowItem::onPickup(%this,%obj,%col,%a)
{
  for(%i=0;%i<%col.getdatablock().maxTools;%i++)
  {
    %item = %col.tool[%i];
    if(%item $= 0 || %item $= "")
    {
      %freeSlot = 1;
      break;
    }
  }
  if(%obj.canpickup && !isobject(%col.getmountedimage(1)) && %freeSlot) { %col.mountimage(BOCrossbowBackImage,1); }
  parent::onPickup(%this,%obj,%col,%a);
}

package BOCrossbowPackage
{
  function servercmdDropTool(%this,%slot)
  {
    if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot].getname() $= "BOCrossbowItem")
    {
      parent::servercmdDropTool(%this,%slot);
      if(isobject(%this.player.getmountedimage(1)) && %this.player.getmountedimage(1).getname() $= "BOCrossbowBackImage") { %this.player.schedule(5,unmountimage,1); }
      return;
    }
    parent::servercmdDropTool(%this,%slot);
  }
};


function BOCrossbowImage::onMount(%this, %obj, %slot)
{		
	Parent::onMount(%this,%obj,%slot);
	%obj.hideNode("RHand");
	%obj.hideNode("RHook");
	%obj.hideNode("LHand");
	%obj.hideNode("LHook");
	commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["BOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4);
  	if(%obj.getMountedImage(1).getName() $= "BOCrossbowBackImage")
	{
	 	%obj.unMountImage(1);
	}
}


function BOCrossbowImage::onUnMount(%this, %obj, %slot)
{	
  	%obj.mountImage(BOCrossbowBackImage,1);

	Parent::onMount(%this,%obj,%slot);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
		applyDefaultCharacterPrefs(%obj);
}



function BOCrossbowSightsImage::onMount(%this, %obj, %slot)
{	
	Parent::onMount(%this,%obj,%slot);
	%client = %obj.client;
	%client.player.setDataBlock("BOCrossbowArmor");
	%obj.hideNode("RHand");
	%obj.hideNode("RHook");
	%obj.hideNode("LHand");
	%obj.hideNode("LHook"); 

}


function BOCrossbowSightsImage::onUnMount(%this, %obj, %slot)
{	
	Parent::onMount(%this,%obj,%slot);
	%obj.unHideNode("ALL");
	%client = %obj.client;
		if(!isObject(%client.minigame))
		{
			%client.player.setDataBlock("PlayerStandardArmor");
			%client.setControlCameraFov(90);
		}
		else
		{
			%client.player.setdatablock(%client.minigame.playerDatablock);
		}
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
		applyDefaultCharacterPrefs(%obj);
}

registerOutputEvent("Player", "Refill_BOCrossbowAmmo");

function Player::Refill_BOCrossbowAmmo(%obj, %client)
{
//    %obj.toolAmmo[%obj.currTool] = 1;
    %obj.client.quantity["BOCrossbowReloadAmmo"] += 2;
    %obj.client.quantity["BOCrossbowReloadCount"] = 0;
    commandToClient(%obj.client,'centerPrint',"<just:right>\c6Explosive \c7Arrows \c6picked up", 1, 2, 3, 4);
    if(%obj.client.quantity["BOCrossbowReloadAmmo"] > 6)
    {
	
	%obj.client.quantity["BOCrossbowReloadAmmo"] = 6;

    }  
}

package BOCrossbowSightsSwitch
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%client = %obj.client;
		if(%triggerNum == 4 && %obj.isImageMounted(BOCrossbowImage) && %val && %obj.toolAmmo[%obj.currTool] != 0)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(BOCrossbowSightsImage, 0, 0, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
			%client.setControlCameraFov(50);
		}
		else if(%triggerNum == 4 && %obj.isImageMounted(BOCrossbowSightsImage) && %val)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(BOCrossbowImage, 0, 0, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
			%client.setControlCameraFov(90);
	         
		}

		Parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
activatePackage(BOCrossbowSightsSwitch);
activatepackage(BOCrossbowPackage);


























