//RegBOCrossbow.cs

//audio
datablock AudioProfile(RegBOCrossbowfireSound)
{
   filename    = "./BOCrossbowfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RegBOCrossbowClipinSound)
{
   filename    = "./BOCrossbowclipin.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RegBOCrossbowClipoutSound)
{
   filename    = "./BOCrossbowclipout.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RegBOCrossbowdeploySound)
{
   filename    = "./BOCrossbowdeploy.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RegBOCrossbowhitSound)
{
   filename    = "./BOCrossbowBHit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock DecalData(RegBOCrossbowDecal)
{
 textureName = "./CI_BOCrossbow";
};

datablock PlayerData(RegBOCrossbowArmor : PlayerStandardArmor)
{
	firstPersonOnly=1;

   runForce = 10 * 180;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 2.1;
   maxBackwardSpeed = 2.1;
   maxSideSpeed = 2.1;

   maxForwardCrouchSpeed = 0.8;
   maxBackwardCrouchSpeed = 0.6;
   maxSideCrouchSpeed = 0.6;

   jumpForce = 8 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;


	uiName = "";
	showEnergyBar = false;

   runSurfaceAngle  = 45;
   jumpSurfaceAngle = 45;
};

datablock ParticleData(ShrapTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 225;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/ring";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.0 0.0 0.0";
	colors[1]     = "0.0 0.0 0.0 0.1";
	sizes[0]      = 0.15;
	sizes[1]      = 0.25;

	useInvAlpha = false;
};
datablock ParticleEmitterData(ShrapTrailEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ShrapTrailParticle";
};

datablock ParticleData(RegBOCrossbowflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./bullethole.png";
	spinSpeed		= 0.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0.0 0.0 0.0 0.0";
	colors[1]     = "0.0 0.0 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 0.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RegBOCrossbowflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RegBOCrossbowflashParticle";

};

//Bullet Explosion
datablock ExplosionData(RegBOCrossbowexplosion)
{
   //explosionShape = "";
	soundProfile = RegBOCrossbowhitSound;

   lifeTimeMS = 150;

   particleEmitter = gunExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = gunExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};


datablock ExplosionData(RegBOCrossbowMW2weaponRecoilExplosion)
{
  lifeTimeMS = 10;
  explosionScale = "0 1 0";
  shakeCamera = true;
  camShakeFreq = "0 1 0";
  camShakeAmp = "0 1 0";
  camShakeDuration = 1.0;
  camShakeRadius = 0.5;
};

datablock ProjectileData(RegBOCrossbowMW2weaponRecoil)
{
  uiName = "";
  explosion = RegBOCrossbowMW2weaponRecoilExplosion;
  muzzleVelocity = 0;
  velInheritFactor = 1;
  lifetime = 1;
  fadeDelay = 1;
  explodeOnDeath = true;
};


AddDamageType("RegBOCrossbow",   '<bitmap:add-ons/Weapon_BO_Crossbow/CI_BOCrossbow> %1',    '%2 <bitmap:add-ons/Weapon_BO_Crossbow/CI_BOCrossbow> %1',0.2,1);
datablock ProjectileData(RegBOCrossbowprojectile)
{
   projectileShapeName = "./Arrow.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::RegBOCrossbow;
   radiusDamageType    = $DamageType::RegBOCrossbow;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 35;
   verticalImpulse	  = 2;
   explosion           = RegBOCrossbowExplosion;
   particleEmitter     = "ShrapTrailEmitter";

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 5000;
   fadeDelay           = 4500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   bounceAngle         = 170;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

};


AddDamageType("RegBOCrossbows",   '<bitmap:add-ons/Weapon_BO_Crossbow/CI_BOCrossbow> %1',    '%2 <bitmap:add-ons/Weapon_BO_Crossbow/CI_BOCrossbow> %1',0.2,1);
datablock ProjectileData(RegBOCrossbowsprojectile)
{
   projectileShapeName = "./Arrow.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::RegBOCrossbows;
   radiusDamageType    = $DamageType::RegBOCrossbows;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 35;
   verticalImpulse	  = 2;
   explosion           = RegBOCrossbowExplosion;
   particleEmitter     = "ShrapTrailEmitter"; 

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 5000;
   fadeDelay           = 4500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   bounceAngle         = 170;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "RegBOCrossbow Bullet";
};

//////////
// item //
//////////
datablock ItemData(RegBOCrossbowItem)
{
	category = "Weapon";
	className = "Weapon"; 

	 // Basic Item Properties
	shapeFile = "./BrBOCrossbow.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "BO Crossbow_Regular";
	iconName = "./Icon_RegBOCrossbow";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = RegBOCrossbowImage;
	canDrop = true;
	
	//Ammo Guns Parameters
	maxAmmo = 1;
	canReload = 1;
};

datablock ShapeBaseImageData(RegBOCrossbowImage)
{
   // Basic Item properties
   shapeFile = "./BOCrossbow.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = RegBOCrossbowItem;
   ammo = " ";
   projectile = RegBOCrossbowprojectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = RegBOCrossbowItem.colorShiftColor;
   // Initial start up state - Ammo mod by Space Guy, base states taken from L4Pistol by Bushido!
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.3;
	stateTransitionOnTimeout[0]     = "LoadCheckA";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "ClipOut";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 0.3;
	stateTransitionOnTimeout[2]     = "Smoke";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = true;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= RegBOCrossbowflashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= RegBOCrossbowfireSound;
	stateEjectShell[2]              = true;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateTimeoutValue[3]	= 0.03;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTimeout[3]	= "FireLoadCheckA";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.03;
	stateScript[4]                  = "";
	stateTransitionOnTriggerUp[4] = "Delay";
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "ReadyWeap";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.2;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "ClipOut";

	stateName[8]				= "ClipOut";
	stateTimeoutValue[8]			= 1.0;
	stateScript[8]				= "onReloadStart";
	stateSequence[8]		= "ClipOut";
	stateAllowImageChange[8]        = true;
	stateTransitionOnTimeout[8]		= "ClipIn";
	stateSound[8]				= RegBOCrossbowclipoutSound;
	
	stateName[9]				= "ClipIn";
	stateTimeoutValue[9]			= 2.0;
	stateScript[9]				= "";
	stateSequence[9]		= "ClipIn";
	stateAllowImageChange[9]        = true;
	stateTransitionOnTimeout[9]		= "reloadFinish";
	stateSound[9]				= RegBOCrossbowclipinSound;
	
	stateName[10]				= "reloadFinish";
	stateTimeoutValue[10]			= 0.2;
	stateScript[10]				= "onReloaded";
	stateAllowImageChange[10]        = true;
	stateTransitionOnTimeout[10]		= "Ready";
	
	stateName[11]				= "FireLoadCheckA";
	stateScript[11]				= "onLoadCheck";
	stateTimeoutValue[11]			= 0.01;
	stateTransitionOnTimeout[11]		= "FireLoadCheckB";
	
	stateName[12]				= "FireLoadCheckB";
	stateTransitionOnAmmo[12]		= "Wait";
	stateTransitionOnNoAmmo[12]		= "ReloadWait";
	
	stateName[13]				= "Delay";
	stateTransitionOnTimeout[13]		= "Ready";
	stateTimeoutValue[13] 			= 0.00001;
	
	stateName[14]				= "ReadyWeap";
	stateSequence[14]			= "Use";
	stateTimeoutValue[14] 			= 0.8;
	stateSound[14]			= RegBOCrossbowdeploySound;
	stateTransitionOnTimeout[14]		= "Ready";
};
datablock ShapeBaseImageData(RegBOCrossbowSightsImage)
{
   shapeFile = "./BOCrossbow.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "-0.6083 -0.45 -2.07";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = RegBOCrossbowItem;
   ammo = " ";
   projectile = RegBOCrossbowsprojectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;
   canDrop = true;

   doColorShift = true;
   colorShiftColor = RegBOCrossbowItem.colorShiftColor;
   
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.01;
	stateTransitionOnTimeout[0]     = "LoadCheckA";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "reloadSequence";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 0.3;
	stateTransitionOnTimeout[2]     = "Smoke";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = true;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= RegBOCrossbowflashEmitter;
	stateEmitterTime[2]		= 0.03;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= RegBOCrossbowfireSound;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateTimeoutValue[3]		= 0.04;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTimeout[3] = "FireLoadCheckA";

	stateName[4]			= "Wait";
	stateEjectShell[2]              = true;
	stateTimeoutValue[4]		= 0.05;
	stateScript[4]                  = "";
	stateTransitionOnTriggerUp[4] = "Delay";
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "Ready";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "reloadSequence";
	
	stateName[8]				= "reloadSequence";
	stateScript[8]				= "setRegBOCrossbowZorro";
	
	stateName[9]				= "FireLoadCheckA";
	stateScript[9]				= "onLoadCheck";
	stateTimeoutValue[9]			= 0.01;
	stateTransitionOnTimeout[9]		= "FireLoadCheckB";
	
	stateName[10]				= "FireLoadCheckB";
	stateTransitionOnAmmo[10]		= "Wait";
	stateTransitionOnNoAmmo[10]		= "ReloadWait";
	
	stateName[11]				= "Delay";
	stateTransitionOnTimeout[11]		= "Ready";
	stateTimeoutValue[11]			= 0.106;
};

datablock ShapeBaseImageData(RegBOCrossbowBackImage)
{
  shapeFile = "./BrBOCrossbow.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "0.2 -0.7 -0.1";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("0 25 0");
  armReady = false;
  doColorShift = false;
};

function RegBOCrossbow2SpawnProj(%this,%obj,%slot)
{
	if(vectorLen(%obj.getVelocity()) < 0.5 && (getSimTime() - %obj.lastShotTime) > 500)
		%spread = 0.000;
	else
		%spread = 0.000;
	if(vectorLen(%obj.getVelocity()) < 1 && (getSimTime() - %obj.lastShotTime) > 600 && %obj.getMountedImage(0) == nameToID(RegBOCrossbowSightsImage))
		%spread = 0.000;
	else if(vectorLen(%obj.getVelocity()) < 1 && (getSimTime() - %obj.lastShotTime) > 1150 && %obj.getMountedImage(0) == nameToID(RegBOCrossbowSightsImage))
		%spread = 0.000;

	%p = new (%this.projectileType)()
	{
    	  dataBlock = RegBOCrossbowMW2weaponRecoil;
    	  initialVelocity = VectorAdd(%vector1,%vector2);
    	  initialPosition = %obj.getEyePoint();
    	  sourceObject = %obj;
    	  sourceSlot = %slot;
    	  client = %obj.client;
  	};
	%projectile = RegBOCrossbowsprojectile;
	%shellcount = 1;
        	%obj.toolAmmo[%obj.currTool]--;
	%obj.lastShotTime = getSimTime();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function RegBOCrossbowSightsImage::onFire(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool]--;
      	%obj.client.quantity["RegBOCrossbowReloadCount"] += 1; 
      	commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["RegBOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4);
            	if(%obj.toolAmmo[%obj.currTool] >= 2)
            	{
            	%obj.toolAmmo[%obj.currTool] = 1;
            	}	

	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		RegBOCrossbow2SpawnProj(%this,%obj,%slot);
	}
	else if(%this.item.maxAmmo == 0)
	{
		RegBOCrossbow2SpawnProj(%this,%obj,%slot);
	}
		Parent::onFire(%this,%obj,%slot);
}


function RegBOCrossbowImage::onFire(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool]--;
      	%obj.client.quantity["RegBOCrossbowReloadCount"] += 1; 
      	commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["RegBOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4);
            	if(%obj.toolAmmo[%obj.currTool] >= 2)
            	{
            	%obj.toolAmmo[%obj.currTool] = 1;
            	}	

	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		RegBOCrossbowSpawnProj(%this,%obj,%slot);
	}
	else if(%this.item.maxAmmo == 0)
	{
		RegBOCrossbowSpawnProj(%this,%obj,%slot);
	}
		Parent::onFire(%this,%obj,%slot);
}	

function RegBOCrossbowImage::onReloadStart(%this,%obj,%slot)
{
    if(%obj.client.quantity["RegBOCrossbowReloadAmmo"] == 0)
    {
    commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["RegBOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4);
    return;
    }
//	%obj.toolAmmo[%obj.currTool] = 0;
}


function RegBOCrossbowImage::onReloaded(%this,%obj,%slot)
{

	if(%obj.client.quantity["RegBOCrossbowReloadAmmo"] >= 1)
        {
        if(%obj.client.quantity["RegBOCrossbowReloadAmmo"] >= 1)
            {
            %obj.client.quantity["RegBOCrossbowReloadAmmo"] -= %obj.client.quantity["RegBOCrossbowReloadCount"];
	        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	        %obj.setImageAmmo(%slot,1);
            if(%obj.client.quantity["RegBOCrossbowReloadAmmo"] < 1)
            {
            %obj.client.quantity["RegBOCrossbowReloadAmmo"] = 0;
            }
            if(%obj.toolAmmo[%obj.currTool] >= 2)
            {
            %obj.toolAmmo[%obj.currTool] = 1;
            }
            commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: 1 | " @ %obj.client.quantity["RegBOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4); 
            %obj.client.quantity["RegBOCrossbowReloadCount"] = 0;
            }
        else
            {
	        %obj.toolAmmo[%obj.currTool] += %obj.client.quantity["RegBOCrossbowReloadAmmo"];  
	        %obj.setImageAmmo(%slot,1);
            %obj.client.quantity["RegBOCrossbowReloadAmmo"] = 0;
            if(%obj.client.quantity["RegBOCrossbowReloadAmmo"] < 1)
            {
            %obj.client.quantity["RegBOCrossbowReloadAmmo"] = 0;
            }
            if(%obj.toolAmmo[%obj.currTool] >= 2)
            {
            %obj.toolAmmo[%obj.currTool] = 1;
            }
            commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["RegBOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4); 
            %obj.client.quantity["RegBOCrossbowReloadCount"] = 0;
            }
        }
    else
        {
        messageClient(%client,'','\c3Man, You ain\'t got the weapon for this');
        }
	%obj.mountImage(RegBOCrossbowImage, 0, 0, 0);
}

function RegBOCrossbowmage::onReloadWait(%this,%obj,%slot)
{
    if(%obj.client.quantity["RegBOCrossbowReloadAmmo"] == 0)
    {
    commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["RegBOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4);
    return;
    }
}

function RegBOCrossbowSpawnProj(%this,%obj,%slot)
{
	if(vectorLen(%obj.getVelocity()) < 0.5 && (getSimTime() - %obj.lastShotTime) > 500)
		%spread = 0.002;
	else
		%spread = 0.008;
	if(vectorLen(%obj.getVelocity()) < 1 && (getSimTime() - %obj.lastShotTime) > 600 && %obj.getMountedImage(0) == nameToID(RegBOCrossbowSightsImage))
		%spread = 0.005;
	else if(vectorLen(%obj.getVelocity()) < 1 && (getSimTime() - %obj.lastShotTime) > 1150 && %obj.getMountedImage(0) == nameToID(RegBOCrossbowSightsImage))
		%spread = 0.002;


	%projectile = RegBOCrossbowprojectile;
	%shellcount = 1;
        	%obj.toolAmmo[%obj.currTool]--;
	%obj.lastShotTime = getSimTime();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function RegBOCrossbowItem::onPickup(%this,%obj,%col,%a)
{
  for(%i=0;%i<%col.getdatablock().maxTools;%i++)
  {
    %item = %col.tool[%i];
    if(%item $= 0 || %item $= "")
    {
      %freeSlot = 1;
      break;
    }
  }
  if(%obj.canpickup && !isobject(%col.getmountedimage(1)) && %freeSlot) { %col.mountimage(RegBOCrossbowBackImage,1); }
  parent::onPickup(%this,%obj,%col,%a);
}

package RegBOCrossbowPackage
{
  function servercmdDropTool(%this,%slot)
  {
    if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot].getname() $= "RegBOCrossbowItem")
    {
      parent::servercmdDropTool(%this,%slot);
      if(isobject(%this.player.getmountedimage(1)) && %this.player.getmountedimage(1).getname() $= "RegBOCrossbowBackImage") { %this.player.schedule(5,unmountimage,1); }
      return;
    }
    parent::servercmdDropTool(%this,%slot);
  }
};


function RegBOCrossbowImage::onMount(%this, %obj, %slot)
{		
	Parent::onMount(%this,%obj,%slot);
	%obj.hideNode("RHand");
	%obj.hideNode("RHook");
	%obj.hideNode("LHand");
	%obj.hideNode("LHook");
	commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["RegBOCrossbowReloadAmmo"] @ "", 1, 2, 3, 4);
  	if(%obj.getMountedImage(1).getName() $= "RegBOCrossbowBackImage")
	{
	 	%obj.unMountImage(1);
	}
}


function RegBOCrossbowImage::onUnMount(%this, %obj, %slot)
{	
  	%obj.mountImage(RegBOCrossbowBackImage,1);

	Parent::onMount(%this,%obj,%slot);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
		applyDefaultCharacterPrefs(%obj);
}



function RegBOCrossbowSightsImage::onMount(%this, %obj, %slot)
{	
	Parent::onMount(%this,%obj,%slot);
	%client = %obj.client;
	%client.player.setDataBlock("RegBOCrossbowArmor");
	%obj.hideNode("RHand");
	%obj.hideNode("RHook");
	%obj.hideNode("LHand");
	%obj.hideNode("LHook"); 

}


function RegBOCrossbowSightsImage::onUnMount(%this, %obj, %slot)
{	
	Parent::onMount(%this,%obj,%slot);
	%obj.unHideNode("ALL");
	%client = %obj.client;
		if(!isObject(%client.minigame))
		{
			%client.player.setDataBlock("PlayerStandardArmor");
			%client.setControlCameraFov(90);
		}
		else
		{
			%client.player.setdatablock(%client.minigame.playerDatablock);
		}
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
		applyDefaultCharacterPrefs(%obj);
}

registerOutputEvent("Player", "Refill_RegBOCrossbowAmmo");

function Player::Refill_RegBOCrossbowAmmo(%obj, %client)
{
//    %obj.toolAmmo[%obj.currTool] = 1;
    %obj.client.quantity["RegBOCrossbowReloadAmmo"] += 6;
    %obj.client.quantity["RegBOCrossbowReloadCount"] = 0;
    commandToClient(%obj.client,'centerPrint',"<just:right>\c6Regular \c7Arrows \c6picked up", 1, 2, 3, 4);
    if(%obj.client.quantity["RegBOCrossbowReloadAmmo"] > 24)
    {
	
	%obj.client.quantity["RegBOCrossbowReloadAmmo"] = 24;

    }  
}

package RegBOCrossbowSightsSwitch
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%client = %obj.client;
		if(%triggerNum == 4 && %obj.isImageMounted(RegBOCrossbowImage) && %val && %obj.toolAmmo[%obj.currTool] != 0)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(RegBOCrossbowSightsImage, 0, 0, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
			%client.setControlCameraFov(50);
		}
		else if(%triggerNum == 4 && %obj.isImageMounted(RegBOCrossbowSightsImage) && %val)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(RegBOCrossbowImage, 0, 0, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
			%client.setControlCameraFov(90);
	         
		}

		Parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
activatePackage(RegBOCrossbowSightsSwitch);
activatepackage(RegBOCrossbowPackage);












